<template>
    <div class="container mx-auto flex flex-col items-center bg-gray-100 p-4">
        <div class="container">
            <AddTicker
                :coin-list="coinList"
                :tickers="tickers"
                :tips-count="4"
                @add-ticker="addToTickers"
            />

            <hr class="w-full border-t border-gray-600 my-4" />

            <PaginationRow
                v-model:page="page"
                :coins-per-page="coinsPerPage"
                :has-next-page="hasNextPage"
            />

            <FilterRow
                v-model:filter="filter"
            />

            <hr class="w-full border-t border-gray-600 my-4" />

            <TickerList
                v-if="paginatedTickers.length"
                v-model:selected-ticker="selectedTicker"
                :tickers="paginatedTickers"
                :coinList="coinList"
                @remove-ticker="removeTicker"
            />

            <hr
                v-if="paginatedTickers.length"
                class="w-full border-t border-gray-600 my-4"
            />

            <TickerGraph
                ref="graph"
                v-model:selected-ticker="selectedTicker"
                :graph="graph"
            />
        </div>
    </div>
</template>

<script>
    import { loadTickers, subscribeToTicker, unsubscribeFromTicker } from "@/api";
    import AddTicker from "@/components/AddTicker";
    import FilterRow from "@/components/FilterRow";
    import PaginationRow from "@/components/PaginationRow";
    import TickerList from "@/components/TickerList";
    import TickerGraph from "@/components/TickerGraph";

    const COINS_PER_PAGE = 6;
    const GRAPH_ITEM_WIDTH = 40;

    export default {
        name: 'App',

        components: {
            TickerList,
            FilterRow,
            PaginationRow,
            AddTicker,
            TickerGraph
        },

        data() {
            return {
                coinList: [],
                page: 1,
                filter: '',

                inputTicker: '',

                tickers: [],
                selectedTicker: null,

                graph: [],
                maxGraphElements: 1,
            }
        },

        created() {
            // BECAUSE HOOKS NOT ASYNC USE THEN
            loadTickers().then(result => {
                this.coinList = result
            });

            const windowData = Object.fromEntries(new URL(window.location).searchParams.entries());

            this.page = Number(windowData.page) || 1;
            this.filter = windowData.filter || '';

            const tickersData = localStorage.getItem('coin-list');

            if (tickersData) {
                this.tickers = JSON.parse(tickersData);

                this.tickers.forEach((ticker) => {
                    subscribeToTicker(ticker.name, 'USD', (newPrice) => {
                        this.updateTicker(ticker.name, newPrice);
                    });
                });
            }
        },

        mounted() {
            window.addEventListener('resize', this.calculateMaxGraphElements);
        },

        beforeUnmount() {
            window.removeEventListener('resize', this.calculateMaxGraphElements);
        },

        computed: {
            coinsPerPage () {
                return COINS_PER_PAGE;
            },

            startIndex () {
                return (this.page - 1) * this.coinsPerPage;
            },

            endIndex () {
                return this.startIndex + this.coinsPerPage;
            },

            hasNextPage () {
                return this.page * this.coinsPerPage < this.filteredTickers.length;
            },

            filteredTickers () {
                return this.tickers.filter(ticker => ticker.name.includes(this.filter.toUpperCase()));
            },

            paginatedTickers () {
                return this.filteredTickers.slice(this.startIndex, this.endIndex);
            },

            pageStateOptions () {
                return {
                    page: this.page,
                    filter: this.filter
                }
            }
        },

        methods: {
            isTickerExists (tokenName) {
                if (!this.coinList.length) {
                    return true;
                }

                return this.coinList.find(ticker => ticker.Symbol === tokenName);
            },

            calculateMaxGraphElements () {
                if (!this.$refs.graph) {
                    return;
                }

                this.maxGraphElements = this.$refs.graph.$el.clientWidth / GRAPH_ITEM_WIDTH;
            },

            updateTicker(tickerName, price) {
                this.tickers
                    .filter(ticker => ticker.name === tickerName)
                    .forEach(ticker => {
                        if (ticker.name === this.selectedTicker) {
                            this.graph.push(price);

                            if (this.graph.length > this.maxGraphElements) {
                                const start = this.graph.length - this.maxGraphElements - 1;
                                this.graph = this.graph.slice(start);
                            }
                        }

                        ticker.price = price;
                    });

            },

            addToTickers(tickerName) {
                this.filter = '';

                if (tickerName === '') {
                    return;
                }

                const newTicker = {
                    name: tickerName.toUpperCase(),
                    price: '-',
                }

                this.tickers = [...this.tickers, newTicker];
                this.inputTicker = '';

                subscribeToTicker(newTicker.name, 'USD', newPrice =>
                    this.updateTicker(newTicker.name, newPrice)
                );
            },

            removeTicker(tickerToRemove) {
                this.tickers = this.tickers.filter(t => t !== tickerToRemove);
                this.selectedTicker = null;

                if (this.selectedTicker === tickerToRemove) {
                    this.selectedTicker = null;
                }

                unsubscribeFromTicker(tickerToRemove.name);
            }
        },

        watch: {
            selectedTicker () {
                this.graph = [];

                this.$nextTick(() => {
                    this.calculateMaxGraphElements()
                })
            },

            tickers: {
                handler() {
                    localStorage.setItem('coin-list', JSON.stringify(this.tickers));
                },
                deep: true
            },

            pageStateOptions (value) {
                window.history.pushState(
                    null,
                    document.title,
                    `${window.location.pathname}?filter=${value.filter}&page=${value.page}`
                );
            },

            paginatedTickers () {
                if (this.paginatedTickers.length === 0 && this.page > 1) {
                    this.page-=1;
                }
            },

            filter () {
                this.page = 1
            }
        }
    }
</script>

<style src="./app.css"></style>
